Bug 194184 (webkit-gtk2) - [arm] www/webkit-gtk2/3 has unimplemented features on ARM
Summary: [arm] www/webkit-gtk2/3 has unimplemented features on ARM
Status: Closed FIXED
Alias: webkit-gtk2
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: arm Any
: --- Affects Many People
Assignee: freebsd-gnome mailing list
URL: http://chips.ysv.freebsd.org/data/11a...
Keywords:
Depends on:
Blocks:
 
Reported: 2014-10-06 13:47 UTC by Sean Bruno
Modified: 2014-12-18 17:10 UTC (History)
3 users (show)

See Also:
kwm: maintainer-feedback+


Attachments
patch-Source__JavaScriptCore__jit__ExecutableAllocator.h (476 bytes, text/x-chdr)
2014-10-16 12:34 UTC, mikael.urankar
no flags Details
same patch, but for webkit-gtk3 as the clear cache code has moved (530 bytes, text/x-c)
2014-12-15 16:35 UTC, Sean Bruno
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sean Bruno freebsd_committer 2014-10-06 13:47:44 UTC
Currently, webkit-gtk2 can't build due to missing implementations, probably asm.

In file included from ./Source/JavaScriptCore/assembler/MacroAssemblerCodeRef.h:29:
./Source/JavaScriptCore/jit/ExecutableAllocator.h:227:6: error: "The cacheFlush support is missing on this platform."
    #error "The cacheFlush support is missing on this platform."
Comment 1 Bugzilla Automation freebsd_committer 2014-10-06 13:47:44 UTC
Auto-assigned to maintainer gnome@FreeBSD.org
Comment 2 mikael.urankar 2014-10-11 09:40:12 UTC
I've tried to compile it with --disable-jit but if failed 10 hours later with this error:
/usr/bin/ld: Programs/.libs/jsc-1: hidden symbol `__aeabi_f2uiz' in /usr/lib/libgcc.a(fixunssfsi.o) is referenced by DSO
/usr/bin/ld: final link failed: Nonrepresentable section on output
Comment 3 mikael.urankar 2014-10-16 12:34:13 UTC
Created attachment 148371 [details]
patch-Source__JavaScriptCore__jit__ExecutableAllocator.h
Comment 4 mikael.urankar 2014-10-16 12:35:20 UTC
The port compiles fine with clang and the attached patch.
Comment 5 mikael.urankar 2014-11-28 14:31:44 UTC
__clear_cache function is available on ARM since r251791 (https://svnweb.freebsd.org/base?view=revision&revision=251791)

build log on armv6:
http://mikael.urankar.free.fr/FreeBSD/arm/build_logs/webkit-gtk2-1.8.3_6.log
Comment 7 John Nielsen 2014-12-04 17:01:17 UTC
I was having the same error on a Raspberry Pi (B). The attached patch allowed the port to build for me.
Comment 8 Koop Mast freebsd_committer 2014-12-14 00:57:16 UTC
Please go ahead for webkit-gtk2 and webkit-gtk3. I was planning on including this in a update to the webkit ports I'm working on. But webkit is not cooperating.
Comment 9 Sean Bruno freebsd_committer 2014-12-15 16:35:20 UTC
Created attachment 150608 [details]
same patch, but for webkit-gtk3 as the clear cache code has moved
Comment 10 commit-hook freebsd_committer 2014-12-18 17:09:50 UTC
A commit references this bug:

Author: sbruno
Date: Thu Dec 18 17:09:46 UTC 2014
New revision: 374913
URL: https://svnweb.freebsd.org/changeset/ports/374913

Log:
  Add support for the clear_cache() function for the ARM platform on FreeBSD.

  Ports now compile on ARM.

  PR:		194184
  Submitted by:	mikael.urankar@gmail.com
  Reviewed by:	kwm@
  Approved by:	mentor (implicit)

Changes:
  head/www/webkit-gtk2/Makefile
  head/www/webkit-gtk2/files/patch-Source__JavaScriptCore__jit__ExecutableAllocator.h
  head/www/webkit-gtk3/Makefile
  head/www/webkit-gtk3/files/patch-Source__JavaScriptCore__assembler__ARMAssembler.h